### Class

# GnomeAutoar Extractor

#### Description

    final class GnomeAutoar.Extractor : GObject.Object
    {
      /* No available fields */
    }

No description available.

#### Hierarchy

#### Ancestors

- GObject

#### Constructors

###### autoar_extractor_new

Create a new `AutoarExtractor` object.

#### Functions

###### autoar_extractor_quark

Gets the `AutoarExtractor` Error Quark.

#### Instance methods

###### autoar_extractor_get_completed_files

Gets the number of files has been written to disk.

###### autoar_extractor_get_completed_size

Gets the size in bytes has been written to disk.

###### autoar_extractor_get_delete_after_extraction

Whether the source archive will be deleted after a successful extraction.

###### autoar_extractor_get_notify_interval

See autoar_extractor_set_notify_interval().

###### autoar_extractor_get_output_file

Gets the `GFile` object which represents the output directory of extracted file or directory, or the extracted file or directory itself if you set `AutoarExtractor:output-is-dest` on the returned object.

###### autoar_extractor_get_output_is_dest

See autoar_extractor_set_output_is_dest().

###### autoar_extractor_get_source_file

Gets the `GFile` object which represents the source archive that will be extracted for this object.

###### autoar_extractor_get_total_files

Gets the total number of files will be written when the operation is completed.

###### autoar_extractor_get_total_size

Gets the size in bytes will be written when the operation is completed.

###### autoar_extractor_set_delete_after_extraction

By default `AutoarExtractor:delete-after-extraction` is set to `FALSE` so the source archive will not be automatically deleted if extraction succeeds.

###### autoar_extractor_set_notify_interval

Sets the minimal interval between emission of `AutoarExtractor::progress` signal. This prevent too frequent signal emission, which may cause performance impact. If you do not want this feature, you can set the interval to 0, so you will receive every progress update.

###### autoar_extractor_set_output_is_dest

By default `AutoarExtractor:output-is-dest` is set to `FALSE`, which means only one file or directory will be created in `AutoarExtractor:output-file`. The destination is internally determined by analyzing the contents of the archive. If this is not wanted, `AutoarExtractor:output-is-dest` can be set to `TRUE`, which will make `AutoarExtractor:output-file` the destination for extracted files. In any case, the destination will be notified via `AutoarExtractor::decide-destination`, when it is possible to set a new destination.

###### autoar_extractor_set_passphrase

Sets a passphrase to use if the file to decompress is passphrase-protected.

###### autoar_extractor_start

Runs the archive extracting work. All callbacks will be called in the same thread as the caller of this functions.

###### autoar_extractor_start_async

Asynchronously runs the archive extracting work. You should connect to `AutoarExtractor::cancelled`, `AutoarExtractor::error`, and `AutoarExtractor::completed` signal to get notification when the work is terminated. All callbacks will be called in the main thread, so you can safely manipulate GTK widgets in the callbacks.

##### Methods inherited from GObject (43)

Please see GObject for a full list of methods.

#### Properties

###### GnomeAutoar.Extractor:completed-files

No description available.

###### GnomeAutoar.Extractor:completed-size

No description available.

###### GnomeAutoar.Extractor:delete-after-extraction

No description available.

###### GnomeAutoar.Extractor:notify-interval

No description available.

###### GnomeAutoar.Extractor:output-file

No description available.

###### GnomeAutoar.Extractor:output-is-dest

No description available.

###### GnomeAutoar.Extractor:source-file

No description available.

###### GnomeAutoar.Extractor:total-files

No description available.

###### GnomeAutoar.Extractor:total-size

No description available.

#### Signals

###### GnomeAutoar.Extractor::cancelled

This signal is emitted after archive extracting job is cancelled by the `GCancellable`.

###### GnomeAutoar.Extractor::completed

This signal is emitted after the archive extracting job is successfully completed.

###### GnomeAutoar.Extractor::conflict

This signal is used to report and offer the possibility to solve name conflicts when extracting files. If it is not handled, the `file` will be skipped.

###### GnomeAutoar.Extractor::decide-destination

This signal is emitted when the path of the destination is determined. It is useful for solving name conflicts or for setting a new destination, based on the contents of the archive.

###### GnomeAutoar.Extractor::error

This signal is emitted when error occurs and all jobs should be terminated. Possible error domains are `AUTOAR_EXTRACTOR_ERROR`, `G_IO_ERROR`, and `AUTOAR_LIBARCHIVE_ERROR`, which represent error occurs in `AutoarExtractor`, GIO, and libarchive, respectively. The `GError` is owned by `AutoarExtractor` and should not be freed.

###### GnomeAutoar.Extractor::progress

This signal is used to report progress of extraction.

###### GnomeAutoar.Extractor::request-passphrase

This signal is emitted when the archive extracting job needs a passphrase.

###### GnomeAutoar.Extractor::scanned

This signal is emitted when `AutoarExtractor` finish scanning filename entries in the source archive.

##### Signals inherited from GObject (1)

###### GObject::notify

The notify signal is emitted on an object when one of its properties has its value set through g_object_set_property(), g_object_set(), et al.

#### Class structure

    struct GnomeAutoarExtractorClass {
      GObjectClass parent_class;

    }

No description available.

###### Class members

`parent_class: GObjectClass`

  No description available.